//************************************************************************************************************************** 
//* BlueBase64
//* Copyright (c) 2002 Josh Harler
//* 
//* This software is provided 'as-is', without any express or implied warranty. In no event
//* will the authors be held liable for any damages arising from the use of this software.
//* 
//* Permission is granted to anyone to use this software for any purpose, including commercial
//* applications, and to alter it and redistribute it freely, subject to the following restrictions:
//* 
//* 	1. The origin of this software must not be misrepresented; you must not claim that you
//* 	wrote the original software. If you use this software in a product, an acknowledgment in the
//* 	product documentation would be appreciated but is not required.
//* 
//* 	2. Altered source versions must be plainly marked as such, and must not be misrepresented as
//* 	being the original software.
//* 
//* 	3. This notice may not be removed or altered from any source distribution.
//*
//*
//* file   Base64DecodeFilter.h
//**

#ifndef __blueBase64_Base64DecodeFilter_h_included__
#define __blueBase64_Base64DecodeFilter_h_included__

// Public Headers ==========================================================================================================

#include "Blue/Data/FilterChunk.h"

// Public Defines/Enums/Typedefs/Etc. ======================================================================================

using namespace blue;

// Public Classes/Structs ==================================================================================================

/**
 * \class Base64DecodeFilter
 * \brief Base64 decodes the data stream.
 */
class BLUE_EXPORT Base64DecodeFilter :public data::Filter
{
public:
	/** Constructor. */
	Base64DecodeFilter();

	/** Destructor. */
	virtual ~Base64DecodeFilter();

	virtual bool canRead() const;

	virtual void write( uint8_t byte );

	virtual uint8_t read();

	virtual void streamClosed();

	virtual void reset();


private:
	void process();

	uint8_t m_input[4];
	int     m_inputCnt;

	uint8_t m_output[3];
	int     m_outputCnt;
	int     m_outputSkip;
};


// Public External Variables ===============================================================================================

// Public Function Prototypes ==============================================================================================

// Public Inline Functions =================================================================================================

#endif // include guard
