//************************************************************************************************************************** 
//* BlueBase64
//* Copyright (c) 2002 Josh Harler
//* 
//* This software is provided 'as-is', without any express or implied warranty. In no event
//* will the authors be held liable for any damages arising from the use of this software.
//* 
//* Permission is granted to anyone to use this software for any purpose, including commercial
//* applications, and to alter it and redistribute it freely, subject to the following restrictions:
//* 
//* 	1. The origin of this software must not be misrepresented; you must not claim that you
//* 	wrote the original software. If you use this software in a product, an acknowledgment in the
//* 	product documentation would be appreciated but is not required.
//* 
//* 	2. Altered source versions must be plainly marked as such, and must not be misrepresented as
//* 	being the original software.
//* 
//* 	3. This notice may not be removed or altered from any source distribution.
//*
//*
//* file   Base64LineFormatter.cpp
//**

// Private Headers =========================================================================================================

// matching header
#include "Base64LineFormatter.h"


// Private Defines/Enums/Typedefs/Etc ======================================================================================

// Private Classes/Structs =================================================================================================

// Private Global Variables ================================================================================================

// External Global Variables ===============================================================================================

// Private Functions =======================================================================================================

// Functions ===============================================================================================================

Base64LineFormatter::Base64LineFormatter( int maxCharsPerLine )
	:FilterChunk(1, 2), m_maxCharsPerLine(maxCharsPerLine), m_curChars(0)
{
}

// -------------------------------------------------------------------------------------------------------------------------

Base64LineFormatter::~Base64LineFormatter()
{
}

// -------------------------------------------------------------------------------------------------------------------------

void Base64LineFormatter::reset()
{
	FilterChunk::reset();
	m_curChars = 0;
}

// -------------------------------------------------------------------------------------------------------------------------

void Base64LineFormatter::processChunk( uint8_t* chunkIn, int chunkInSize, uint8_t* chunkOut, int& chunkOutSize )
{
	chunkOut[0] = chunkIn[0];
	chunkOutSize = 1;

	if( ++m_curChars == m_maxCharsPerLine ) {
		chunkOut[1] = '\n';
		++chunkOutSize;
		m_curChars = 0;
	}
}
